package org.xtext.example.mydsl.tests

import org.eclipse.xtext.junit4.InjectWith;
import org.junit.runner.RunWith;

import com.google.inject.Inject;
import org.eclipse.xtext.junit4.XtextRunner
import org.eclipse.xtext.junit4.formatter.FormatterTester
import org.junit.Test

@RunWith(XtextRunner)
@InjectWith(MyDslInjectorProvider)
public class TestFormatter {

	@Inject extension FormatterTester

	@Test
	def void testLongLastLinePart() {
		assertFormatted[
			toBeFormatted = '''
if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION", "FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST", "MODIFICATION_PAYMENT_FREQUENCY", "MODIFICATION_PREMIUM_BENEFIT_INCREASE", "MODIFICATION_PREMIUM_INTERRUPTION", "MODIFICATION_SURPLUS_PARAMETERS", "HALLO" ("ENABLED")
	
if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION", "FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST", "MODIFICATION_PAYMENT_FREQUENCY", "MODIFICATION_PREMIUM_BENEFIT_INCREASE", "MODIFICATION_PREMIUM_INTERRUPTION", "MODIFICATION_SURPLUS_PARAMETERS", "HALLO" ("ENABLED")
'''
			expectation = '''
if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION",
	"FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST",
	"MODIFICATION_PAYMENT_FREQUENCY", "MODIFICATION_PREMIUM_BENEFIT_INCREASE", "MODIFICATION_PREMIUM_INTERRUPTION",
	"MODIFICATION_SURPLUS_PARAMETERS", "HALLO"
("ENABLED")
	
if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION",
	"FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST",
	"MODIFICATION_PAYMENT_FREQUENCY", "MODIFICATION_PREMIUM_BENEFIT_INCREASE", "MODIFICATION_PREMIUM_INTERRUPTION",
	"MODIFICATION_SURPLUS_PARAMETERS", "HALLO"
("ENABLED")
'''
		]
	}
	
		@Test
	def void testShortLastLinePart() {
		assertFormatted[
			toBeFormatted = '''
if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION", "FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST", "MODIFICATION_PAYMENT_FREQUENCY", "MODIFICATION_PREMIUM_BENEFIT_INCREASE", "MODIFICATION_PREMIUM_INTERRUPTION", "MODIFICATION_SURPLUS_PARAMETERS" ("ENABLED")
	
if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION", "FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST", "MODIFICATION_PAYMENT_FREQUENCY", "MODIFICATION_PREMIUM_BENEFIT_INCREASE", "MODIFICATION_PREMIUM_INTERRUPTION", "MODIFICATION_SURPLUS_PARAMETERS" ("ENABLED")
'''
			expectation = '''
if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION",
	"FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST",
	"MODIFICATION_PAYMENT_FREQUENCY", "MODIFICATION_PREMIUM_BENEFIT_INCREASE", "MODIFICATION_PREMIUM_INTERRUPTION",
	"MODIFICATION_SURPLUS_PARAMETERS"
("ENABLED")
	
if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION",
	"FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST",
	"MODIFICATION_PAYMENT_FREQUENCY", "MODIFICATION_PREMIUM_BENEFIT_INCREASE", "MODIFICATION_PREMIUM_INTERRUPTION",
	"MODIFICATION_SURPLUS_PARAMETERS"
("ENABLED")
'''
		]
	}
	
//	@Test
//	def void testEntitiesFormatter2() {
//		assertFormatted[
//			toBeFormatted = '''
//if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION", "FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST"
//("ENABLED")
//	
//if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION", "FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST"
//("ENABLED")
//'''
//			expectation = '''
//if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION",
//	"FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST"
//("ENABLED")
//	
//if: "businessProcessType" = "CVBPTAntrag", "ADDITIONAL_PAYMENT", "BENEFIT_DEATH_ANNUITIZATION", "COVER_INCLUSION",
//	"FUND_SWITCH_SHIFT", "MODIFICATION_EMPLOYMENT_BEGIN_END", "MODIFICATION_FUND_FUTURE_INVEST"
//("ENABLED")
//'''
//		]
//	}
}
