package org.xtext.example.mydsl.tests;

import com.google.inject.Inject;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.junit4.InjectWith;
import org.eclipse.xtext.junit4.XtextRunner;
import org.eclipse.xtext.junit4.formatter.FormatterTestRequest;
import org.eclipse.xtext.junit4.formatter.FormatterTester;
import org.eclipse.xtext.xbase.lib.Extension;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.xtext.example.mydsl.tests.MyDslInjectorProvider;

@RunWith(XtextRunner.class)
@InjectWith(MyDslInjectorProvider.class)
@SuppressWarnings("all")
public class TestFormatter {
  @Inject
  @Extension
  private FormatterTester _formatterTester;
  
  @Test
  public void testLongLastLinePart() {
    final Procedure1<FormatterTestRequest> _function = (FormatterTestRequest it) -> {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("if: \"businessProcessType\" = \"CVBPTAntrag\", \"ADDITIONAL_PAYMENT\", \"BENEFIT_DEATH_ANNUITIZATION\", \"COVER_INCLUSION\", \"FUND_SWITCH_SHIFT\", \"MODIFICATION_EMPLOYMENT_BEGIN_END\", \"MODIFICATION_FUND_FUTURE_INVEST\", \"MODIFICATION_PAYMENT_FREQUENCY\", \"MODIFICATION_PREMIUM_BENEFIT_INCREASE\", \"MODIFICATION_PREMIUM_INTERRUPTION\", \"MODIFICATION_SURPLUS_PARAMETERS\", \"HALLO\" (\"ENABLED\")");
      _builder.newLine();
      _builder.append("\t");
      _builder.newLine();
      _builder.append("if: \"businessProcessType\" = \"CVBPTAntrag\", \"ADDITIONAL_PAYMENT\", \"BENEFIT_DEATH_ANNUITIZATION\", \"COVER_INCLUSION\", \"FUND_SWITCH_SHIFT\", \"MODIFICATION_EMPLOYMENT_BEGIN_END\", \"MODIFICATION_FUND_FUTURE_INVEST\", \"MODIFICATION_PAYMENT_FREQUENCY\", \"MODIFICATION_PREMIUM_BENEFIT_INCREASE\", \"MODIFICATION_PREMIUM_INTERRUPTION\", \"MODIFICATION_SURPLUS_PARAMETERS\", \"HALLO\" (\"ENABLED\")");
      _builder.newLine();
      it.setToBeFormatted(_builder);
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("if: \"businessProcessType\" = \"CVBPTAntrag\", \"ADDITIONAL_PAYMENT\", \"BENEFIT_DEATH_ANNUITIZATION\", \"COVER_INCLUSION\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"FUND_SWITCH_SHIFT\", \"MODIFICATION_EMPLOYMENT_BEGIN_END\", \"MODIFICATION_FUND_FUTURE_INVEST\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"MODIFICATION_PAYMENT_FREQUENCY\", \"MODIFICATION_PREMIUM_BENEFIT_INCREASE\", \"MODIFICATION_PREMIUM_INTERRUPTION\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"MODIFICATION_SURPLUS_PARAMETERS\", \"HALLO\"");
      _builder_1.newLine();
      _builder_1.append("(\"ENABLED\")");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.newLine();
      _builder_1.append("if: \"businessProcessType\" = \"CVBPTAntrag\", \"ADDITIONAL_PAYMENT\", \"BENEFIT_DEATH_ANNUITIZATION\", \"COVER_INCLUSION\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"FUND_SWITCH_SHIFT\", \"MODIFICATION_EMPLOYMENT_BEGIN_END\", \"MODIFICATION_FUND_FUTURE_INVEST\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"MODIFICATION_PAYMENT_FREQUENCY\", \"MODIFICATION_PREMIUM_BENEFIT_INCREASE\", \"MODIFICATION_PREMIUM_INTERRUPTION\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"MODIFICATION_SURPLUS_PARAMETERS\", \"HALLO\"");
      _builder_1.newLine();
      _builder_1.append("(\"ENABLED\")");
      _builder_1.newLine();
      it.setExpectation(_builder_1);
    };
    this._formatterTester.assertFormatted(_function);
  }
  
  @Test
  public void testShortLastLinePart() {
    final Procedure1<FormatterTestRequest> _function = (FormatterTestRequest it) -> {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("if: \"businessProcessType\" = \"CVBPTAntrag\", \"ADDITIONAL_PAYMENT\", \"BENEFIT_DEATH_ANNUITIZATION\", \"COVER_INCLUSION\", \"FUND_SWITCH_SHIFT\", \"MODIFICATION_EMPLOYMENT_BEGIN_END\", \"MODIFICATION_FUND_FUTURE_INVEST\", \"MODIFICATION_PAYMENT_FREQUENCY\", \"MODIFICATION_PREMIUM_BENEFIT_INCREASE\", \"MODIFICATION_PREMIUM_INTERRUPTION\", \"MODIFICATION_SURPLUS_PARAMETERS\" (\"ENABLED\")");
      _builder.newLine();
      _builder.append("\t");
      _builder.newLine();
      _builder.append("if: \"businessProcessType\" = \"CVBPTAntrag\", \"ADDITIONAL_PAYMENT\", \"BENEFIT_DEATH_ANNUITIZATION\", \"COVER_INCLUSION\", \"FUND_SWITCH_SHIFT\", \"MODIFICATION_EMPLOYMENT_BEGIN_END\", \"MODIFICATION_FUND_FUTURE_INVEST\", \"MODIFICATION_PAYMENT_FREQUENCY\", \"MODIFICATION_PREMIUM_BENEFIT_INCREASE\", \"MODIFICATION_PREMIUM_INTERRUPTION\", \"MODIFICATION_SURPLUS_PARAMETERS\" (\"ENABLED\")");
      _builder.newLine();
      it.setToBeFormatted(_builder);
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("if: \"businessProcessType\" = \"CVBPTAntrag\", \"ADDITIONAL_PAYMENT\", \"BENEFIT_DEATH_ANNUITIZATION\", \"COVER_INCLUSION\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"FUND_SWITCH_SHIFT\", \"MODIFICATION_EMPLOYMENT_BEGIN_END\", \"MODIFICATION_FUND_FUTURE_INVEST\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"MODIFICATION_PAYMENT_FREQUENCY\", \"MODIFICATION_PREMIUM_BENEFIT_INCREASE\", \"MODIFICATION_PREMIUM_INTERRUPTION\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"MODIFICATION_SURPLUS_PARAMETERS\"");
      _builder_1.newLine();
      _builder_1.append("(\"ENABLED\")");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.newLine();
      _builder_1.append("if: \"businessProcessType\" = \"CVBPTAntrag\", \"ADDITIONAL_PAYMENT\", \"BENEFIT_DEATH_ANNUITIZATION\", \"COVER_INCLUSION\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"FUND_SWITCH_SHIFT\", \"MODIFICATION_EMPLOYMENT_BEGIN_END\", \"MODIFICATION_FUND_FUTURE_INVEST\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"MODIFICATION_PAYMENT_FREQUENCY\", \"MODIFICATION_PREMIUM_BENEFIT_INCREASE\", \"MODIFICATION_PREMIUM_INTERRUPTION\",");
      _builder_1.newLine();
      _builder_1.append("\t");
      _builder_1.append("\"MODIFICATION_SURPLUS_PARAMETERS\"");
      _builder_1.newLine();
      _builder_1.append("(\"ENABLED\")");
      _builder_1.newLine();
      it.setExpectation(_builder_1);
    };
    this._formatterTester.assertFormatted(_function);
  }
}
