/*
 * generated by Xtext 2.10.0
 */
package org.xtext.example.mydsl.formatting2

import com.google.inject.Inject
import org.eclipse.xtext.formatting2.AbstractFormatter2
import org.eclipse.xtext.formatting2.IFormattableDocument
import org.xtext.example.mydsl.myDsl.Model
import org.xtext.example.mydsl.myDsl.Rules
import org.xtext.example.mydsl.services.MyDslGrammarAccess
import org.xtext.example.mydsl.myDsl.ConditionAtom
import org.eclipse.xtext.formatting2.IAutowrapFormatter
import org.eclipse.xtext.formatting2.regionaccess.IHiddenRegion
import org.eclipse.xtext.formatting2.regionaccess.IWhitespace
import org.xtext.example.mydsl.myDsl.Condition
import org.xtext.example.mydsl.myDsl.Result

class MyDslFormatter extends AbstractFormatter2 {
	
	@Inject extension MyDslGrammarAccess
	
	def dispatch void format(Model model, extension IFormattableDocument document) {
		for (Rules rules : model.getRules()) {
			rules.format;
		}
	}

	def dispatch void format(Rules rules, extension IFormattableDocument document) {
		rules.getCondition.format;
		rules.getResult.format;
	}
	
	def dispatch void format(Result result, extension IFormattableDocument document){
		result.regionFor.keyword("(").prepend[newLine]
	}
	
	def dispatch void format(Condition condition, extension IFormattableDocument document) {
		format(condition.condition, document);
	}

	private static class BooleanWrapper {
		boolean first = true;
		
		def isFirst(){
			return first;
		}
		
		def setIsFirst(boolean value){
			first = value;
		}
	}
	
	def dispatch void format(ConditionAtom conditionatom, extension IFormattableDocument document) {
		val firstIndent = new BooleanWrapper() // needed to prevent double indent if line is autowrapped twice
		val access = conditionAtomAccess
		val IAutowrapFormatter autoWrapIndent  = [region, wrapped, doc |
			if (firstIndent.isFirst){
				firstIndent.isFirst = false
				val first = (region as IWhitespace).hiddenRegion
				val last = conditionatom.regionForEObject.nextHiddenRegion
				println("indent white for " + first.offset + " to " + last.offset + " (" + region.textRegionAccess.regionForDocument.text.substring(first.offset, last.offset) + ") ")
				doc.set(first, last, [indent])
			}
		]
		conditionatom.allRegionsFor.keywords(",").forEach[append[autowrap; onAutowrap = autoWrapIndent]]
	}
}
