/**
 * generated by Xtext 2.10.0
 */
package org.xtext.example.mydsl.formatting2;

import com.google.inject.Inject;
import java.util.Arrays;
import java.util.List;
import java.util.function.Consumer;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.formatting2.AbstractFormatter2;
import org.eclipse.xtext.formatting2.IAutowrapFormatter;
import org.eclipse.xtext.formatting2.IFormattableDocument;
import org.eclipse.xtext.formatting2.IHiddenRegionFormatter;
import org.eclipse.xtext.formatting2.IHiddenRegionFormatting;
import org.eclipse.xtext.formatting2.regionaccess.IEObjectRegion;
import org.eclipse.xtext.formatting2.regionaccess.IHiddenRegion;
import org.eclipse.xtext.formatting2.regionaccess.ISemanticRegion;
import org.eclipse.xtext.formatting2.regionaccess.ISemanticRegionsFinder;
import org.eclipse.xtext.formatting2.regionaccess.ITextRegionAccess;
import org.eclipse.xtext.formatting2.regionaccess.ITextSegment;
import org.eclipse.xtext.formatting2.regionaccess.IWhitespace;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.xbase.lib.Extension;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.xtext.example.mydsl.myDsl.Condition;
import org.xtext.example.mydsl.myDsl.ConditionAtom;
import org.xtext.example.mydsl.myDsl.Model;
import org.xtext.example.mydsl.myDsl.Result;
import org.xtext.example.mydsl.myDsl.Rules;
import org.xtext.example.mydsl.services.MyDslGrammarAccess;

@SuppressWarnings("all")
public class MyDslFormatter extends AbstractFormatter2 {
  private static class BooleanWrapper {
    private boolean first = true;
    
    public boolean isFirst() {
      return this.first;
    }
    
    public boolean setIsFirst(final boolean value) {
      return this.first = value;
    }
  }
  
  @Inject
  @Extension
  private MyDslGrammarAccess _myDslGrammarAccess;
  
  protected void _format(final Model model, @Extension final IFormattableDocument document) {
    EList<Rules> _rules = model.getRules();
    for (final Rules rules : _rules) {
      document.<Rules>format(rules);
    }
  }
  
  protected void _format(final Rules rules, @Extension final IFormattableDocument document) {
    Condition _condition = rules.getCondition();
    document.<Condition>format(_condition);
    Result _result = rules.getResult();
    document.<Result>format(_result);
  }
  
  protected void _format(final Result result, @Extension final IFormattableDocument document) {
    ISemanticRegionsFinder _regionFor = this.textRegionExtensions.regionFor(result);
    ISemanticRegion _keyword = _regionFor.keyword("(");
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.prepend(_keyword, _function);
  }
  
  protected void _format(final Condition condition, @Extension final IFormattableDocument document) {
    ConditionAtom _condition = condition.getCondition();
    this.format(_condition, document);
  }
  
  protected void _format(final ConditionAtom conditionatom, @Extension final IFormattableDocument document) {
    final MyDslFormatter.BooleanWrapper firstIndent = new MyDslFormatter.BooleanWrapper();
    final MyDslGrammarAccess.ConditionAtomElements access = this._myDslGrammarAccess.getConditionAtomAccess();
    final IAutowrapFormatter _function = (ITextSegment region, IHiddenRegionFormatting wrapped, IFormattableDocument doc) -> {
      boolean _isFirst = firstIndent.isFirst();
      if (_isFirst) {
        firstIndent.setIsFirst(false);
        final IHiddenRegion first = ((IWhitespace) region).getHiddenRegion();
        IEObjectRegion _regionForEObject = this.textRegionExtensions.regionForEObject(conditionatom);
        final IHiddenRegion last = _regionForEObject.getNextHiddenRegion();
        int _offset = first.getOffset();
        String _plus = ("indent white for " + Integer.valueOf(_offset));
        String _plus_1 = (_plus + " to ");
        int _offset_1 = last.getOffset();
        String _plus_2 = (_plus_1 + Integer.valueOf(_offset_1));
        String _plus_3 = (_plus_2 + " (");
        ITextRegionAccess _textRegionAccess = region.getTextRegionAccess();
        ITextSegment _regionForDocument = _textRegionAccess.regionForDocument();
        String _text = _regionForDocument.getText();
        int _offset_2 = first.getOffset();
        int _offset_3 = last.getOffset();
        String _substring = _text.substring(_offset_2, _offset_3);
        String _plus_4 = (_plus_3 + _substring);
        String _plus_5 = (_plus_4 + ") ");
        InputOutput.<String>println(_plus_5);
        final Procedure1<IHiddenRegionFormatter> _function_1 = (IHiddenRegionFormatter it) -> {
          it.indent();
        };
        doc.set(first, last, _function_1);
      }
    };
    final IAutowrapFormatter autoWrapIndent = _function;
    ISemanticRegionsFinder _allRegionsFor = this.textRegionExtensions.allRegionsFor(conditionatom);
    List<ISemanticRegion> _keywords = _allRegionsFor.keywords(",");
    final Consumer<ISemanticRegion> _function_1 = (ISemanticRegion it) -> {
      final Procedure1<IHiddenRegionFormatter> _function_2 = (IHiddenRegionFormatter it_1) -> {
        it_1.autowrap();
        it_1.setOnAutowrap(autoWrapIndent);
      };
      document.append(it, _function_2);
    };
    _keywords.forEach(_function_1);
  }
  
  public void format(final Object condition, final IFormattableDocument document) {
    if (condition instanceof XtextResource) {
      _format((XtextResource)condition, document);
      return;
    } else if (condition instanceof Condition) {
      _format((Condition)condition, document);
      return;
    } else if (condition instanceof ConditionAtom) {
      _format((ConditionAtom)condition, document);
      return;
    } else if (condition instanceof Model) {
      _format((Model)condition, document);
      return;
    } else if (condition instanceof Result) {
      _format((Result)condition, document);
      return;
    } else if (condition instanceof Rules) {
      _format((Rules)condition, document);
      return;
    } else if (condition instanceof EObject) {
      _format((EObject)condition, document);
      return;
    } else if (condition == null) {
      _format((Void)null, document);
      return;
    } else if (condition != null) {
      _format(condition, document);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(condition, document).toString());
    }
  }
}
